Attribute VB_Name = "CboExpand"
'********************************************************************
' Description:      enhance combo control with autoexpand
' Programmer:       Damian Minchev
' Creation Date:    August-29-2000
' Note: Correct typed letter with use only a BackSpace, user can't use DEL or arrows
'       - but if you wont more - then you shoud code youself :)
'********************************************************************

Option Explicit

Public Sub cboKeyPress(cbo As ComboBox, ByRef sTyped As String, ByRef KeyAscii As Integer)

If KeyAscii = vbKeyReturn Then
  '  go to next cotrol
      'SendKeys "{tab}"
      'KeyAscii = 0
    Exit Sub
End If
' if is press combination like ctr+xx
If KeyAscii < 46 And KeyAscii <> vbKeyEscape And KeyAscii <> vbKeyBack And KeyAscii <> vbKeySpace Then
    Exit Sub
End If

  AutoExpand cbo, sTyped, KeyAscii
End Sub

' Desc: Ensure user do not leave combo if he isn't enter value from combo's list (if combo is such type (2) )
Public Sub cboLostFocus(cbo As ComboBox, sTyped As String, Optional listcboEdittable As String = "")
         ' if value for this this combo must present in it list
    If Not bEditTable(cbo.Name, listcboEdittable) Then
        If Not bEntryIsInList(cbo, cbo.Text) Then ' if Value isn't in list
           'On Error Resume Next
          If cbo.Text = "" Then ' if user didn't entry nothing - then he can leave combo
            sTyped = ""
            Exit Sub
          End If
            On Error Resume Next
            cbo.SetFocus
            On Error GoTo 0
            cbo.Text = ""
            sTyped = ""
         '   bCancelExit = True
            Beep
            Exit Sub
           
         End If
      End If
   
   sTyped = ""
End Sub

Public Sub AutoExpand(cbo As ComboBox, ByRef sTyped As String, ByRef KeyAscii As Integer)
On Error GoTo errHold

 If cbo.Style = 2 Then MsgBox "Combo with autoexpand must be Style 0 or 1 !", vbCritical, "From autoExpand"
 If cbo.Text = "" Or KeyAscii = vbKeyEscape Then
  sTyped = ""
  cbo.Text = ""
   If KeyAscii = 27 Then
      KeyAscii = 0
      Exit Sub
   End If
End If
 
 If KeyAscii <> vbKeyBack Then
   sTyped = sTyped & Chr(KeyAscii)
   FillCombo cbo, sTyped, KeyAscii
 Else ' press backSpace
   If sTyped <> "" Then
     sTyped = Left(sTyped, Len(sTyped) - 1)
     FillCombo cbo, sTyped, KeyAscii
   End If
 End If
 
 ' Disable new key - all entry in combo is trought code !
 KeyAscii = 0
 Exit Sub

errHold: ' this is just for any case
 MsgBox "Error in autodetect in list !" & Chr(13) & "Please, select item with mouse or press Esc key and enter letters again !", vbInformation
End Sub

Private Sub FillCombo(cbo As ComboBox, ByRef sTyped As String, ByRef KeyAscii As Integer)
Dim newStr As String
   newStr = FindNearless(cbo, sTyped)
   If newStr = "" Then
    cbo.Text = sTyped
    cbo.SelLength = Len(sTyped)
    cbo.ListIndex = -1
    KeyAscii = 0
    Exit Sub
  End If
   cbo.Text = newStr
   cbo.SelLength = Len(sTyped)
End Sub

Private Function FindNearless(cbo As ComboBox, str As String)
Dim i As Integer
 For i = 0 To cbo.ListCount - 1
   If UCase(Left(cbo.List(i), Len(str))) = UCase(str) Then
    FindNearless = cbo.List(i)
    cbo.ListIndex = i
    Exit For
   End If
 Next
End Function

Private Function bEntryIsInList(cbo As ComboBox, str As String) As Boolean
  If FindNearless(cbo, str) = "" Then bEntryIsInList = False Else bEntryIsInList = True
End Function

Private Function bEditTable(cboName As String, listcboEdittable As String) As Boolean
Dim mas, i As Integer

If listcboEdittable = "" Then
  bEditTable = False
  Exit Function
End If

bEditTable = False
 mas = Split(listcboEdittable, ",", , vbTextCompare)
 For i = 0 To UBound(mas)
   If cboName = mas(i) Then
     bEditTable = True
     Exit For
   End If
 Next
End Function
